function OutIm=ApplyMatrixTransform(InIm,TranformMatrix,K);
% OutIm=ApplyMatrixTransform(InIm,TranformMatrix);
% OutIm     Output image
% InIm      Input image
% Apply Color Transform According to the 3x3 matrix given in TranformMatrix
% K is a constant term OutIm = [TranformMatrix] In + K
%
% Mario Raffin, 10th Jan 2007

insize=size(InIm);
if insize(3)~=3
    error('ERROR: 3 layer image expected.');
    return
end


X = reshape(InIm, prod(insize)/3, 3); 
Y = X * TranformMatrix';

OutIm = reshape(Y, insize);
if (nargin>2)
    OutIm(:,:,1)=OutIm(:,:,1)+K(1);
    OutIm(:,:,2)=OutIm(:,:,2)+K(2);
    OutIm(:,:,3)=OutIm(:,:,3)+K(3);
end